package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIStandardMail implements JET2Template {

    public _jet_JBIStandardMail() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String bindingName = JBIJetUtils.getRightStepBinding(aStep).getName();
	
	String endpointType = "poller";
	if (bindingName.equalsIgnoreCase("JBI-AdvancedEmailReceiver")){
   		endpointType = "poller";
   	}else if (bindingName.equalsIgnoreCase("JBI-AdvancedEmailSender")) {
   		endpointType = "sender";
   	}
   
	
	String mailHost 	=  JBIJetUtils.getRequiredPropertyValue(aStep,"Host");
	String mailPort 	=  JBIJetUtils.getOptionalPropertyValue(aStep,"Port" ,"25");
	String mailUser		=  JBIJetUtils.getOptionalPropertyValue(aStep,"User" ,"anonymous");
	String mailPassword	=  JBIJetUtils.getOptionalPropertyValue(aStep,"Password" ,null);
	
	if (mailUser.equalsIgnoreCase("anonymous")){
		mailPassword = "anonymous@anonymous.com";
	}
	String mailUri = null;
	if (endpointType.equalsIgnoreCase("sender")){
		mailUri = "smtp://"+mailUser+"@"+mailHost+":"+mailPort+"?password="+mailPassword;
	}else{
		mailUri = "imap://"+mailUser+"@"+mailHost+":"+mailPort+"/INBOX?password="+mailPassword;
	}
	

        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         

if (endpointType.equalsIgnoreCase("poller")){

        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(NL);         
        out.write("\t\t\tdepends-on=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\ttargetService=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tconnection=\"");  //$NON-NLS-1$        
        out.write(mailUri);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tperiod=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep,"Period"));
        out.write(";");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tdeleteProcessedMessages=\"false\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            processOnlyUnseenMessages=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        >");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t ");  //$NON-NLS-1$        
        out.write(NL);         
} else {
        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(NL);         
        out.write("\t\t\tdepends-on=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tconnection=\"");  //$NON-NLS-1$        
        out.write(mailUri);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tsender=\"\"\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t >");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
}
    }
}
