package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIStandardSAP implements JET2Template {

    public _jet_JBIStandardSAP() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String bindingName = JBIJetUtils.getRightStepBinding(aStep).getName();
	
	String endpointType = "consumer";
	if (bindingName.equalsIgnoreCase("SAP-ConsumerBindingComponent")){
   		endpointType = "consumer";
   	}else if (bindingName.equalsIgnoreCase("SAP-ProducerBindingComponent")) {
   		endpointType = "provider";
   	}

        out.write(NL);         
        out.write("<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(NL);         
        out.write("\tdepends-on=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\tconnectionDetailFileName=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "ConnectionDetailFileName"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         

	if (endpointType.equalsIgnoreCase("consumer")){
	
        out.write("\t\ttargetService=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
} else {
        out.write("\t\tmapper=\"org.apache.servicemix.sap.bc.mapping.impl.XmlToIdoc\">");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t");  //$NON-NLS-1$        
    }
}
