package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.xmi.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import java.util.*;
import java.io.StringWriter;
import java.io.IOException;
import org.spagic.utils.*;
import org.spagic.utils.graph.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_deploy implements JET2Template {

    public _jet_deploy() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        out.write("<?xml version=\"1.0\" encoding=\"utf-8\"?>");  //$NON-NLS-1$        
        out.write(NL);         

	StpIntermediateModel stpModel = (StpIntermediateModel)(context.getVariable("stpModel"));
	String graphVizExeLocation = (String)context.getVariable("graphVizExeLocation");
	String graphVizTempFolder = (String)context.getVariable("graphVizTempFolder");
	String baseNamespace = (String)context.getVariable("baseNamespace");
	List<org.eclipse.stp.im.Process> processesList = stpModel.getProcessCollection().getProcesses();

        out.write("<DEPLOY>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<BASE_NAMESPACE>");  //$NON-NLS-1$        
        out.write(baseNamespace);
        out.write("</BASE_NAMESPACE>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<OBSERVABLE_ATTRIBUTE_REPOSITORY>");  //$NON-NLS-1$        
        out.write(JBIJetUtils.removeXMLHeader(JBIJetUtils.getObservableAttributeXML(processesList)));
        out.write(NL);         
        out.write("</OBSERVABLE_ATTRIBUTE_REPOSITORY>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<INTERMEDIATE_MODEL>");  //$NON-NLS-1$        
        out.write(NL);         

	Resource res = (Resource)context.getSource();

    Map<String, String> options = new HashMap<String, String>();
    //change as needed according to the type of resource
    //you are using
	options.put(XMIResource.OPTION_ENCODING, "UTF-8");
 
	StringWriter sw = new StringWriter();
	URIConverter.WriteableOutputStream uws = new URIConverter.WriteableOutputStream(sw, "UTF-8");
	try{
		res.save(uws, options);
	}catch(IOException e){
		throw new RuntimeException(e);
	}

        out.write(JBIJetUtils.removeXMLHeader(sw.toString()));
        out.write("</INTERMEDIATE_MODEL>");  //$NON-NLS-1$        
        out.write(NL);         

	for ( org.eclipse.stp.im.Process aProcess : processesList){
	
		if (SpagicUtils.isProcessDeployableForRuntime(
			aProcess, JBIJetUtils.getRuntimeId())){
			String processGraph = GraphGenerator.getGraphForProcess(aProcess,
					graphVizExeLocation, graphVizTempFolder);
			
			
        out.write("<PROCESS>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<GRAPH>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(JBIJetUtils.removeXMLHeader(processGraph));
        out.write("</GRAPH>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("</PROCESS>");  //$NON-NLS-1$        
        out.write(NL);         

		}
	}

        out.write("</DEPLOY>");  //$NON-NLS-1$        
        out.write(NL);         
    }
}
