package org.spagic.im.runtime.smx.ext.pdd;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.Collections;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Plugin;
import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;

/**
 * The activator class controls the plug-in life cycle
 */
public class PddExtensionActivator extends Plugin {

	// The plug-in ID
	public static final String PLUGIN_ID = "org.spagic.im.runtime.smx.ext.pdd";

	// The shared instance
	private static PddExtensionActivator plugin;
	
	/**
	 * The constructor
	 */
	public PddExtensionActivator() {
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.core.runtime.Plugins#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.core.runtime.Plugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static PddExtensionActivator getDefault() {
		return plugin;
	}

	public static File getFileFromPlugin(String filePath){
		Bundle bundle = PddExtensionActivator.getDefault().getBundle();
		Path path = new Path(filePath); 
		
		URL url = FileLocator.find(bundle, path, Collections.EMPTY_MAP);
		
		URL fileUrl = null;
		try {
			fileUrl = FileLocator.toFileURL(url);
		}catch (IOException e) {
			// Will happen if the file cannot be read for some reason
			e.printStackTrace();
		}
		return new File(fileUrl.getPath());
	}
}
